#!/bin/sh
# \
exec tclsh "$0" "$@"
#
#   puts stdout "Content-type: text/html\n"

proc domaxima { {m} } {
    set t "display2d:false;\n$m;"
    # return [string range [exec maxima << $t | tail -2  ] 6 end-7]
    return [string range [exec maxima -q << $t ] 32 end-7]
    #return [exec maxima --real-quiet << $t ]
 } 

proc domaximafor { {m} } {
    set t "display2d:false;\nlinel:3000;\nfortran(subst((float(%e)),%e,subst((float(%pi)),%pi,$m)));\n"
    return [string range [exec maxima -q << $t ] 42 end-18]
 } 

proc domaximagraph { {m} } {
    set t "display2d:false;\nlinel:3000;\nplot2d ($m, \[x, 0, 0.1\], \[gnuplot_term, \"gif size 1600,512\"\], \[gnuplot_out_file, \"/dev/shm/gnuplot.gif\"\]);\n"
    return [exec maxima --very-quiet << $t ]
 } 

proc domaximaformula { {m} } {
    #set t "tex($m);"
    set t "display2d:false;\ntex($m);"
    return [string range [exec maxima -q --very-quiet << $t ] 6 end-6]
 } 

proc formake { {e} } {
   global f
   set t [subst -nocommand {
      subroutine sayhello(x,r)
        double precision x,r
        r = $e
        return
      end
   }]
   set f [open /dev/shm/sub.f w]
   puts $f [string trim $t \n]
   close $f
   set env(TMP) /dev/shm/
   set env(TEMP) /dev/shm/
   exec gcc -O3 -ffixed-line-length-none -c -o sub.o /dev/shm/sub.f
   exec gcc -O3 -o synthbw synth.c sub.o -lasound -ljack

#   exec gcc -ffixed-line-length-none -c -o /dev/shm/sub.o /dev/shm/sub.f
#   exec gcc -o /dev/shm/fm /dev/shm/sub.o mw.c wav.o -lm
   #exec gfortran -ffixed-line-length-none -c sub.f
   #exec gcc -o fm sub.o main.c -lm
#   return [exec /dev/shm/fm]
   return 
 } 

proc doformula { m } {
   set t [subst -nocommand {
\\documentclass\{article\}
\\DeclareMathSizes\{16\}\{15\}\{13\}\{11\}

\\begin\{document\}
\\thispagestyle\{empty\}
\\Large
}]
   set f [open /dev/shm/formula.tex w]
   puts $f [string trim $t \n]
   puts $f $m
   puts $f "\\end{document}"
   close $f
   catch { exec latex -output-directory=/dev/shm /dev/shm/formula  > /dev/null  }
   catch { exec dvigif -T tight --gif /dev/shm/formula.dvi -o /dev/shm/formula.gif 2>@ stdout > /dev/null }
}

proc makeprog {form} {
 global makeprogout
 #    cd /dev/shm/S

   set makeprogout ""
   append makeprogout "[clock format [clock seconds]]:\n" 

   append makeprogout "evaluating maxima expression..\n"
   flush stdout
#   append makeprogout "[set in [gets stdin]]<br>--><br>"
   append makeprogout  "[set r [domaxima $form]]\n"
   append makeprogout  "generating Fortran expression from it..\n"
   set s [domaximafor $r]
   append makeprogout  "generating wave..\n"
   append makeprogout  "[formake $s]\n"
   # append makeprogout "making mp3 from wave ..\n"
   # append makeprogout "[exec ffmpeg -i /dev/shm/math.wav -ab 256k -y /dev/shm/math.mp3 >& /dev/null ]\n"
   append makeprogout "making prettyprinted formula ..\n"
   doformula [domaximaformula $r]
   # catch {exec ppmquant 256 /dev/shm/sine.ppm | ppmtogif > /dev/shm/graph1.gif 2> /dev/null}

   append makeprogout end\n
# Makes the cgi-bin script stop the server process thinking there's a connection
#   exit
}
