/* This is file: main.c */
 #include<stdio.h>
 #include <string.h>
 #include <malloc.h>
 #include<math.h>

 #define PI 3.1415926535

 extern void sayhello_(float *, float *);
 extern int initwav(char *,int);
 extern int writewav(short *, int);
 extern void closewav();

 unsigned char *im;
 int w,h;

 unsigned char * createim(w,h)
 int w,h;
 {
   unsigned char *d;
   int x,y;
   d = (unsigned char *) malloc(3*w*h);
   for (x=0; x<w; x++)
      for (y=0; y<h; y++) {
         d[(y*w+x)*3+0] = 0;
         d[(y*w+x)*3+1] = 0;
         d[(y*w+x)*3+2] = 0;
      }
   return d;
 }

 int writeppm(n,w,h)
 char n[];
 int w,h;
 {
   FILE *fp;
   fp = fopen(n,"wb");
   if ((void *) fp == NULL ) return(-1);

   fprintf(fp,"P6\n%d %d\n255\n",w,h);
   fwrite(im, 3, w*h,fp);
   fclose(fp);
   return(0);
 }

 void grid()
 {
   int i,j;

   for (j=0; j<h; j+=25) 
      for (i=0; i<w; i+=1) 
       if ( (j%100) == 0) {
         im[(j*w+i)*3+0] += 16;
         im[(j*w+i)*3+1] += 96;
         im[(j*w+i)*3+2] += 12;
       } else {
         im[(j*w+i)*3+0] += 10;
         im[(j*w+i)*3+1] += 56;
         im[(j*w+i)*3+2] += 8;
       }
   for (i=0; i<w; i+=25)
      for (j=0; j<h; j+=1) 
       if ( (i%100) == 0) {
         im[(j*w+i)*3+0] += 16;
         im[(j*w+i)*3+1] += 96;
         im[(j*w+i)*3+2] += 12;
       } else {
         im[(j*w+i)*3+0] += 10;
         im[(j*w+i)*3+1] += 56;
         im[(j*w+i)*3+2] += 8;
       }
 }

#define point(mx,my,r,g,b) { im[((my)*w+(mx))*3+0] = (r); im[((my)*w+(mx))*3+1] = (g); im[((my)*w+(mx))*3+2] = (b); }

#define point_trans(mx,my,r,g,b,a) { im[((my)*w+(mx))*3+0] += (r/a); im[((my)*w+(mx))*3+1] += (g/a); im[((my)*w+(mx))*3+2] += (b/a); }

#define fpoint(x,y,r,g,b) im[(((int) (0.5+y))*w+((int) (0.5+x)))*3+0] = (r); im[(((int) (0.5+y))*w+((int) (0.5+x)))*3+1] = (g); im[(((int) (0.5+y))*w+((int) (0.5+x)))*3+2] = (b);

 drawsine()
 {
   int i,j,k,l, max;
   double d,e,x;

   max = 1;
   for (x=0; x<2*PI; x+=PI/500) {
      for (k=1; k<=max; k++)
         for (j=h; j>(250-sin(((double) k)*x*4)*250); j--)
            point_trans((int) (0.5 + (x*1000.0)/(2.0*PI)), j, 0, 250, 250, max);
   }
 }

 int main(argc, argv)
 int argc;
 char *argv[];
 {
   float in, out;
   float x, start, stop, incr;
   short s;
   int i, j;

   if (argc == 1) {
      start = 0.0;
      stop = 3.0;
      incr = 1.0/44100.0;
    if (initwav("/dev/shm/math.wav",3*44100) != 0) return((int) -1);
    h = 500; w = 1000;
    im = createim(w,h);
    if (im == NULL) { printf("Malloc error: quiting.\n"); return( (int) -1); }
    i = 0;
    for (x=start; x<(stop-incr/2); x+=incr) {
      in = x;
      sayhello_(&in,&out);
      /* printf("%f %f\n", x, (float) out); */
      s = (short) (32000*out);
      writewav(&s,1);
/*      if (x<0.1) {
         for (j=h; j>(250-250*out); j--)
            point_trans((int) (x*10*1000), j, 0, 250, 250, 1);
      } */
      i++;
    }
    closewav();
   }

   for (x=0.0+0.00001; x<0.1; x+=0.1/1000) {
      in = x;
      sayhello_(&in,&out);
      if (1) {
         for (j=h-1; j>(250-(int) ((float) 250*out)); j--)
            point_trans((int) (x*1000*10), j, 0, 250, 250, 1);
      }
   }

/*   drawsine(); */
   grid();
   writeppm("/dev/shm/sine.ppm", w,h);

   return((int) 0);
 }
